#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <grp.h>
#include <nss.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <string.h>

extern int cpstr( char *str, char **buf, size_t *buflen);

enum nss_status _nss_pag_getgrgid_r (gid_t gid, struct group *result,
 char *buffer, size_t buflen, int *errnop ) {
 	int length;
 	char mybuf[20];
 	char **members;
 	int mode=0;
	if ( ( gid >= 0x7f00 ) && (gid <= 0xbf00) ) {
		mode=1;
	}
	if ( ( gid >> 24 ) == 0x41 ) {
		mode=2;
	}
	if ( ! mode ) {
		*errnop=ENOENT;
		return NSS_STATUS_UNAVAIL;
	}
	switch (mode) {
		case 1:
			/* Old PAG-method using two unix group memberships */
			result->gr_name=buffer;
			length=snprintf(mybuf,sizeof(mybuf),"AfsPag-%i",gid-0x7f00) + 1;
			cpstr(mybuf,&buffer,&buflen);
			break;
		case 2:
			/* New PAG-method showing PAG via a single membership in a 32bit-group */
			result->gr_name=buffer;
			length=snprintf(mybuf,sizeof(mybuf),"AfsPag32-%6x",gid-0x41000000) + 1;
			cpstr(mybuf,&buffer,&buflen);
			break;
	}
	result->gr_passwd=buffer;
	cpstr("x",&buffer,&buflen);
	result->gr_gid=gid;
	members=(void*)buffer;
	buflen=buflen-sizeof(*members);
	*members=0;
	result->gr_mem=members;

	return NSS_STATUS_SUCCESS;
}
