#include <sys/types.h>
#include <pwd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "ptdbnss.h"
#include <nss.h>

extern enum nss_status _nss_ptdb_getpwuid_r (uid_t uid, struct passwd *result_buf,
 char *buffer, size_t buflen, int *errnop );
 
extern enum nss_status _nss_ptdb_getpwnam_r (char *name, struct passwd *result_buf,
 char *buffer, size_t buflen, int *errnop );



int main(int argc,char **argv,char **envp) {
	int buflen=1000;
	char buffer[buflen];
	char *buf;
	char *arg;
	int uid;
	struct passwd pw;
	int err;

	buf=buffer;
	if ( argc != 2 ) {
		printf("Usage: %s [name or id]\n\nAsks NSS for a a name or an UID, returns both.\n",argv[0]);
		exit(1);
	}
	arg=argv[1];
	if ( ( arg[0] > '0' ) && ( arg[0] < '9' ) ) {
		// NAME-Lookup
		uid=atoi(arg);
		if ( _nss_ptdb_getpwuid_r(uid,&pw,buffer,buflen,&err) ) {
			printf("uid=%i name='%s' homedir='%s' gid=%i passwd='%s' shell='%s' err=%i\n",pw.pw_uid,pw.pw_name,pw.pw_dir,pw.pw_gid,pw.pw_passwd,pw.pw_shell,err);
			return 0;
		} else {
			printf("W: unknown uid.\n");
			return 1;
		}
	} else {
		if ( _nss_ptdb_getpwnam_r(arg,&pw,buffer,buflen,&err) ) {
			printf("uid=%i name='%s' homedir='%s' gid=%i passwd='%s' shell='%s' err=%i\n",pw.pw_uid,pw.pw_name,pw.pw_dir,pw.pw_gid,pw.pw_passwd,pw.pw_shell,err);
			return 0;
		} else {
			printf("W: unknown name.\n");
			return 1;
		}
	}
}
