#include <stdint.h>

typedef enum {
	UID_REQUEST=0,
	UID_REPLY=1,
	NAME_REQUEST=2,
	NAME_REPLY=3,
} ptdbnsstype_t;

/* configuration info of the ptdbnssd. It will be sent with any answer */
#define HOMEDIR_USER_1LEVEL 0
#define HOMEDIR_ADMINLINK 1
#define HOMEDIR_HOME_1LEVEL 2
#define HOMEDIR_USER_2LEVEL1X 3
#define HOMEDIR_USER_3LEVEL12X 4
#define HOMEDIR_USEREXT 5
#define HOMEDIR_LOCAL_HOME_MINOR 6
#define HOMEDIR_LOCAL_HOME_CAPITAL 7

#define SHELL_BASH 0
#define SHELL_ADMINLINK 1
#define SHELL_USERLINK 2
#define SHELL_SCPONLY 3

struct ptdbconf_t {
	char homedirs_method;
	char shells_method;
};


struct ptdbnssheader_t {
	int version;
	ptdbnsstype_t ptype;
	struct ptdbconf_t conf;
	uint16_t id;
};

#define ptdbnssdatalength 256-sizeof(struct ptdbnssheader_t)

typedef union {
	uid_t uid;
	char name[ptdbnssdatalength];
} ptdbnssdata_t;


typedef struct {
	struct ptdbnssheader_t header;
	ptdbnssdata_t data;
} ptdbnsspacket_t;

#define TIMEOUT 30
#define PTDBNSSD_PORT 6998
#define NUMOFCHILDS 3


#define HEADERVERSION 2

